%define name gambas3
%define version 3.8.1
%define release %mkrel 1

Name: %{name}
Summary: Complete IDE based on a BASIC interpreter with object extensions
Summary(de): Komplette IDE auf einem BASIC-Interpreter mit Objekt-Erweiterungen basierend
Version: %{version}
Release: %{release}
License: GPLv2+
Group: Development/Other
URL: http://gambas.sourceforge.net/
Source0: http://ovh.dl.sourceforge.net/sourceforge/gambas/%{name}-%{version}.tar.xz
Patch1: gambas2-2.23.0-flags.patch
BuildRoot: %{_tmppath}/%{name}-buildroot
BuildRequires: %{_lib}SDL-devel
BuildRequires: %{_lib}SDL_mixer1.2-devel
BuildRequires: %{_lib}SDL_ttf-devel
BuildRequires: %{_lib}atk1.0-devel
BuildRequires: %{_lib}bzip2-devel
BuildRequires: %{_lib}cairo-devel
BuildRequires: %{_lib}curl-devel
BuildRequires: %{_lib}dbus-1-devel
BuildRequires: %{_lib}ffi5-devel
BuildRequires: %{_lib}gdk_pixbuf2.0_0
BuildRequires: %{_lib}gdk_pixbuf2.0_0-devel
BuildRequires: %{_lib}glew-devel
BuildRequires: %{_lib}glib2.0_0-devel
BuildRequires: %{_lib}gmime-devel
BuildRequires: %{_lib}gmp-devel
BuildRequires: %{_lib}gnome-keyring-devel
BuildRequires: %{_lib}gtk+2.0_0-devel
BuildRequires: %{_lib}gtkglext-devel
BuildRequires: %{_lib}jpeg-devel
BuildRequires: %{_lib}ltdl-devel
BuildRequires: %{_lib}mesagl1-devel
BuildRequires: %{_lib}mesaglu1-devel
BuildRequires: %{_lib}mysql-devel
BuildRequires: %{_lib}ncurses-devel
BuildRequires: %{_lib}openssl-devel
BuildRequires: %{_lib}pango1.0-devel
BuildRequires: %{_lib}pcre0-devel
BuildRequires: %{_lib}png-devel
BuildRequires: %{_lib}poppler-devel
BuildRequires: %{_lib}qt4-devel
BuildRequires: %{_lib}rsvg2-devel
BuildRequires: %{_lib}sqlite0-devel
BuildRequires: %{_lib}sqlite3-devel
BuildRequires: %{_lib}unixODBC-devel
BuildRequires: %{_lib}v4l-devel
BuildRequires: %{_lib}x11-devel
BuildRequires: %{_lib}xcursor-devel
BuildRequires: %{_lib}xext-devel
BuildRequires: %{_lib}xi-devel
BuildRequires: %{_lib}xml2-devel
BuildRequires: %{_lib}xslt-devel
BuildRequires: %{_lib}xtst-devel
BuildRequires: postgresql-devel
BuildRequires: zlib1-devel
BuildRequires: libpthread-stubs
BuildRequires: %{_lib}imlib2-devel
BuildRequires: %{_lib}gsl-devel
BuildRequires: %{_lib}gstreamer1.0-devel
BuildRequires: %{_lib}gstreamer-plugins-base1.0-devel
BuildRequires: llvm-devel
BuildRequires: openal-devel
BuildRequires: alure-devel
BuildRequires: sdl2-devel
BuildRequires: sdl2_mixer-devel
BuildRequires: sdl2_image-devel
BuildRequires: sdl2_ttf-devel
BuildRequires: qtwebkit-devel
BuildRequires: libdrm-devel
BuildRequires: %{_lib}xshmfence-devel
BuildRequires: imagemagick
BuildRequires: libxxf86vm-devel
BuildRequires: gtk+3-devel
BuildRequires: libqt5svg-devel
BuildRequires: libqt5x11extras-devel
BuildRequires: libqt5webkit-devel
BuildRequires: libqt5webkitwidgets-devel
BuildRequires: libqt5core-devel
BuildRequires: libqt5gui-devel
BuildRequires: libqt5network-devel
BuildRequires: libqt5printsupport-devel
Obsoletes:	%name < %version
Obsoletes: gambas2
Provides:  gambas2


%description
Gambas is a free development environment based on a Basic interpreter
with object extensions, like Visual Basic(tm) (but it is NOT a clone!). 
With Gambas, you can quickly design your program GUI, access MySQL or
PostgreSQL databases, control KDE applications with DCOP, translate
your program into many languages, create network applications easily,
build RPMs of your apps automatically, and so on...

%description -l de
Gambas ist eine freie Programmiersprache zur Softwareentwicklung. Es handelt 
sich um eine objektorientierte BASIC- Variante mit einer kompletten IDE. Sie 
soll die Vorteile von Visual Basic auch unter KDE und Gnome verfügbar machen, 
jedoch ist Gambas - anders als allgemein behauptet - nicht äquivalent zu Visual 
Basic, auch wenn die beiden Sprachen viele Gemeinsamkeiten aufweisen. Dieses 
liegt hauptsächlich an dem Wegfall der so genannten ActiveX-Steuerelemente, die 
bei Gambas durch eigene Objekte ersetzt wurden. So sind bereits vorhandene „Visual 
Basic“-Projekte nicht ohne weiteres zu importieren. Gambas ist weiter an C angelehnt 
als Visual Basic. Das zeigt sich z.B. im Umgang mit Dateien, die wie in C als 
Dateideskriptor geöffnet werden.




%prep
%setup -q 
%patch1 -p0

for i in `find . -name "acinclude.m4"`;
do
	sed -i -e 's|AM_CONFIG_HEADER|AC_CONFIG_HEADERS|g' ${i}
	sed -i 's|$AM_CFLAGS -O3|$AM_CFLAGS|g' ${i}
	sed -i 's|$AM_CXXFLAGS -Os -fno-omit-frame-pointer|$AM_CXXFLAGS|g' ${i}
	sed -i 's|$AM_CFLAGS -Os|$AM_CFLAGS|g' ${i}
	sed -i 's|$AM_CFLAGS -O0|$AM_CFLAGS|g' ${i}
	sed -i 's|$AM_CXXFLAGS -O0|$AM_CXXFLAGS|g' ${i}
done

%build
./reconf-all
export CXXFLAGS="%optflags -fpermissive"
%setup_compile_flags
for i in `find -name configure`
do
	(
	  pushd `dirname $i`
	  %before_configure
	  popd
	)
done

%configure2_5x \
	--disable-corba --disable-qte

%make
%install
rm -rf $RPM_BUILD_ROOT
%makeinstall_std

find %{buildroot} -name '*.la' -delete

mkdir -p $RPM_BUILD_ROOT/%{_miconsdir}
mkdir -p $RPM_BUILD_ROOT/%{_iconsdir}
mkdir -p $RPM_BUILD_ROOT/%{_liconsdir}
mkdir -p $RPM_BUILD_ROOT/%{_iconsdir}/hicolor/{16x16,32x32,48x48,128x128}/{apps,mimetypes}
install -m644 app/src/gambas3/img/logo/logo-16.png $RPM_BUILD_ROOT/%{_miconsdir}/%{name}.png
install -m644 app/src/gambas3/img/logo/logo-16.png $RPM_BUILD_ROOT/%{_iconsdir}/hicolor/16x16/apps/%{name}.png
install -m644 app/src/gambas3/img/logo/logo-32.png $RPM_BUILD_ROOT/%{_iconsdir}/%{name}.png
install -m644 app/src/gambas3/img/logo/logo-32.png $RPM_BUILD_ROOT/%{_iconsdir}/hicolor/32x32/apps/%{name}.png
convert -resize 48x48 app/src/gambas3/img/logo/logo.png $RPM_BUILD_ROOT/%{_liconsdir}/%{name}.png
convert -resize 48x48 app/src/gambas3/img/logo/logo.png $RPM_BUILD_ROOT/%{_iconsdir}/hicolor/48x48/apps/%{name}.png
install -m644 app/src/gambas3/img/logo/logo.png $RPM_BUILD_ROOT/%{_iconsdir}/hicolor/128x128/apps/%{name}.png

install -m644 app/mime/application-x-gambasscript.png %buildroot%{_iconsdir}/hicolor/48x48/mimetypes/application-x-gambasscript.png
convert -resize 16x16 app/mime/application-x-gambasscript.png %buildroot%{_iconsdir}/hicolor/16x16/mimetypes/application-x-gambasscript.png
convert -resize 32x32 app/mime/application-x-gambasscript.png %buildroot%{_iconsdir}/hicolor/32x32/mimetypes/application-x-gambasscript.png
install -m644 main/mime/application-x-gambas3.png %buildroot%{_iconsdir}/hicolor/48x48/mimetypes/
convert -resize 16x16 main/mime/application-x-gambas3.png %buildroot%{_iconsdir}/hicolor/16x16/mimetypes/application-x-gambas.png
convert -resize 32x32 main/mime/application-x-gambas3.png %buildroot%{_iconsdir}/hicolor/32x32/mimetypes/application-x-gambas.png

# Clean some files that do not need to be packaged according to docs
rm -f $RPM_BUILD_ROOT%_libdir/%{name}/gb.so $RPM_BUILD_ROOT%_libdir/%{name}/gb.so*

#ln -sf %{_datadir}/fonts/TTF/dejavu/DejaVuSans.ttf %{buildroot}%{_datadir}/gambas3/gb.sdl/DejaVuSans.ttf

# Menu
mkdir -p $RPM_BUILD_ROOT%{_datadir}/applications
cat > $RPM_BUILD_ROOT%{_datadir}/applications/pclinuxos-%{name}.desktop <<EOF
[Desktop Entry]
Name=Gambas III
Comment=Gambas 3 IDE
Exec=%{_bindir}/%{name} 
Icon=%{name}
Terminal=false
Type=Application
StartupNotify=true
Categories=GNOME;GTK;Development;IDE;X-MandrivaLinux-MoreApplications-Development-DevelopmentEnvironments;
EOF

mkdir -p %{buildroot}%{_datadir}/applnk/Applications
#associate the default applications through the applnk folder
cat >  %{buildroot}%{_datadir}/applnk/Applications/pclinuxos-%{name}.desktop <<EOF
[Desktop Entry]
Name=Gambas 3
Comment=Gambas executable
Exec=gbr3
Icon=application-x-gambas
NoDisplay=true
Terminal=false
Type=Application
MimeType=application/x-gambas;
Encoding=UTF-8
EOF


cat >  %{buildroot}%{_datadir}/applnk/Applications/pclinuxos-%{name}script.desktop <<EOF
[Desktop Entry]
Name=Gambas script
Comment=Gambas script interpreter
Exec=gbs3
Icon=application-x-gambasscript
NoDisplay=true
Terminal=false
TerminalOptions=\s--noclose
Type=Application
MimeType=application/x-gambasscript;
Encoding=UTF-8
EOF


# XDG MIME type
install -D app/mime/application-x-gambasscript.xml %buildroot%{_datadir}/mime/packages/application-x-gambasscript.xml
install -D main/mime/application-x-gambas3.xml %buildroot%{_datadir}/mime/packages/application-x-gambas3.xml

#-----------------------------------------------------------------------------
%post
%update_icon_cache hicolor

%postun
%clean_icon_cache hicolor

%files 
%defattr(-, root, root, 0755)
%doc README AUTHORS ChangeLog
%{_bindir}/gbc3
%{_bindir}/gba3
%{_bindir}/gbi3
%{_bindir}/gbx3
%{_bindir}/gbr3
%{_bindir}/gbw3
%{_bindir}/gbs3
%{_bindir}/gbs3.gambas
%{_bindir}/%{name}
%{_bindir}/%{name}.gambas
%ifarch i586
%{_bindir}/gbh3
%{_bindir}/gbh3.gambas
%endif
%{_datadir}/%{name}/icons/application-x-gambasscript.png
%{_datadir}/%{name}/icons/application-x-gambasserverpage.png
#%{_datadir}/%{name}/examples
%{_datadir}/%{name}/control/*
%{_datadir}/%{name}/icons/application-x-gambas3.png
%{_datadir}/%{name}/info/*
#%{_datadir}/%{name}/gb.sdl/*
%{_datadir}/mime/packages/application-x-gambasscript.xml
%{_datadir}/applications/pclinuxos*.desktop
%{_datadir}/appdata/%{name}.appdata.xml
%{_datadir}/applnk/Applications/*.desktop
%{_datadir}/icons/hicolor/48x48/mimetypes/application-x-gambas3.png
%{_datadir}/mime/packages/application-x-gambas3.xml
%{_iconsdir}/hicolor/*/mimetypes/application-x-gambasscript.png
%{_iconsdir}/hicolor/*/mimetypes/application-x-gambas.png
%{_iconsdir}/%{name}.png
%{_liconsdir}/%{name}.png
%{_iconsdir}/hicolor/*/apps/%{name}.png
%{_miconsdir}/%{name}.png
%{_libdir}/%{name}

#-----------------------------------------------------------------------------

%clean
rm -rf $RPM_BUILD_ROOT

%changelog
* Tue Oct 13 2015 bb <bb. 3.8.1-1pclos2015
- update

* Sat Aug 29 2015 ghostbunny <ghostbunny at gmx dot de> 3.8.0-1pclos2015
- 3.8.0 + rebuild against new poppler version
- add BRs for new qt5 module

* Sat Aug 01 2015 bb <bb> 3.7.1-2pclos2015
- rebuild against updated llvm

* Fri Apr 03 2015 ghostbunny <ghostbunny at gmx dot de> 3.7.1-1pclos2015
- 3.7.1
- add BR libthread-stubs, libimlib2-devel, libgsl-devel, llvm-devel, libgstreamer1.0-devel 
  libgstreamer-plugins-base1.0-devel, openal-devel, alure-devel, sdl2-devel, sdl2_mixer-devel,
  sdl2_image-devel, sdl2_ttf-devel, qtwebkit-devel, libdrm-devel, libxshmfence-devel,
  imagemagick, libxxf86vm-devel, gtk+3-devel

* Thu Oct 08 2014 bb <bb> 3.5.1-5pclos2014
- rebuild against updated poppler library

